// BrainActivityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BrainActivity.h"
#include "BrainActivityDlg.h"
#include <cassert>
#include <sstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrainActivityDlg dialog

CBrainActivityDlg::CBrainActivityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrainActivityDlg::IDD, pParent),
	fSession(0),
	fTimerHandle(0),
	fCurrentTimer(1000)
{
	//{{AFX_DATA_INIT(CBrainActivityDlg)
	fTimerEdit = 1000;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBrainActivityDlg::~CBrainActivityDlg()
{
	delete fSession;
}

void CBrainActivityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrainActivityDlg)
	DDX_Control(pDX, IDC_TIMER_BUTTON, fTimerButton);
	DDX_Control(pDX, IDC_DATA_LIST, fDataList);
	DDX_Control(pDX, IDOK, fCloseButton);
	DDX_Control(pDX, IDC_DISCONNECT_BUTTON, fDisconnectButton);
	DDX_Control(pDX, IDC_CONNECT_BUTTON, fConnectButton);
	DDX_Text(pDX, IDC_TIMER_EDIT, fTimerEdit);
	DDV_MinMaxUInt(pDX, fTimerEdit, 0, 30000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrainActivityDlg, CDialog)
	//{{AFX_MSG_MAP(CBrainActivityDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, OnConnectButton)
	ON_BN_CLICKED(IDC_DISCONNECT_BUTTON, OnDisconnectButton)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_TIMER_BUTTON, OnTimerButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrainActivityDlg message handlers

BOOL CBrainActivityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	ResetButtons();
	fCurrentTimer = fTimerEdit;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBrainActivityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBrainActivityDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBrainActivityDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBrainActivityDlg::ResetButtons()
{
	if(fSession != 0) // we are connected
	{
		fConnectButton.EnableWindow(FALSE);
		fDisconnectButton.EnableWindow(TRUE);
		fCloseButton.EnableWindow(FALSE);
	}
	else // we are disconnected
	{
		fConnectButton.EnableWindow(TRUE);
		fDisconnectButton.EnableWindow(FALSE);
		fCloseButton.EnableWindow(TRUE);
	}
}

void CBrainActivityDlg::StartTimer()
{
	if(fTimerHandle != 0)
		StopTimer();

	fTimerHandle = SetTimer(1, fCurrentTimer, 0);
	if(fTimerHandle == 0)
	{
		MessageBox("Unable to start timer");
	}
}

void CBrainActivityDlg::StopTimer()
{
	if(fTimerHandle != 0)
	{
		if(!KillTimer(1))
		{
			MessageBox("Unable to stop timer");
		}
		fTimerHandle = 0;
	}
}


void CBrainActivityDlg::OnConnectButton() 
{
	// TODO: Add your control notification handler code here
	assert(fSession == 0);

	try
	{
		fSession = new Creatures::Session();
		// As a test, get the creatures name and display it
		std::string name = fSession->executeMacro("inst,dde: getb cnam,endm");
		std::string title = "BrainActivity - " + name; 
		SetWindowText(title.c_str());
		ResetButtons();
		StartTimer();	
	}
	catch(Creatures::DDEException&)
	{ 
		MessageBox("An error occurred trying to connect to Creatures.\nPlease ensure that Creatures is running and a norn is selected.",
			"Unable to connect");
	}	
}

void CBrainActivityDlg::OnDisconnectButton() 
{
	// TODO: Add your control notification handler code here
	StopTimer();
	delete fSession;
	fSession = 0;
	ResetButtons();
	SetWindowText("BrainActivity");	
}

void CBrainActivityDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateData(TRUE);

	try
	{
		StopTimer();

		std::string activity = fSession->getBrainActivity();
		if(activity != fOldData)
		{
			fOldData = activity;
			Brain::ResultsVector results = fBrain.parseFromActivity(activity);
			fDataList.ResetContent();
			if(results.empty())
			{
				fDataList.AddString("Nothing");
			}
			Brain::ResultsVector::iterator first = results.begin();
			Brain::ResultsVector::iterator last = results.end();
			while(first != last)
			{
				Brain::Results data = (*first);

				std::string name = fBrain.getLobeName(data.fX, data.fY);
#if 0
				if(name != "Concept" &&
					name != "Drive" &&
					name != "Verb" &&
					name != "Decision")
#endif
				{					
					std::ostringstream stream;
					stream << name
						   << " - "
						   << fBrain.getCellDescription(data.fX, data.fY)
						   << " (" 
						   << data.fValue
						   << ")"
						   << std::ends;
					fDataList.AddString(stream.str().c_str());	
				}
				first++;
			}
		}
	
		StartTimer();
	}
	catch(Creatures::DDEException&)
	{
		MessageBox("DDE Exception");
		OnDisconnectButton();
	}
	
	CDialog::OnTimer(nIDEvent);

	UpdateData(FALSE);
}

void CBrainActivityDlg::OnTimerButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int currentHandle = fTimerHandle;
	if(currentHandle != 0) StopTimer();
	fCurrentTimer = fTimerEdit;
	if(currentHandle != 0) StartTimer();
}
